/* Gtk front-end for About My Cache
   (c) 2001 - Francois Crevola (with the help of Come Desplats)
 */

#include <config.h>
/*
#include <errno.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
*/
#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#if ENABLE_NLS
#include <libintl.h>
#  define _(String) gettext (String)
#else
#  define _(String) (String)
#endif /* ENABLE_NLS */

#include "amyc_logo.xpm"
#include "amyc_prefs.h"
#include "amyc_ns.h"
amyc_prefs prefs;

/* Widget in the config window */
GtkWidget *radio1, *radio2, *radio3, *radio4, *radio5, *radio6;
GtkWidget *entry, *entry2, *entry3;
GtkWidget *entry_removeurl;

GtkWidget * menu_tab[7], *menu;

gint 
delete_event (GtkWidget * widget,
	      GdkEvent * event,
	      gpointer data)
{
    /* Do not destroy ? TRUE or FLASE */
    return (FALSE);
}

/* Another callback */
void 
destroy (GtkWidget * widget,
	 gpointer data)
{
  g_print (_("Bye.\n"));
  gtk_main_quit ();
}

void 
startanalysis (GtkButton *button, gpointer user_data) 
{
    amyc_seq (prefs, 0);
}

void 
runbrowser(GtkButton *button, gpointer user_data) 
{
    amyc_runbrowser (prefs);
}

void
config_ok (GtkWidget *fenetre, GtkButton * button)
{
    int i;
    GtkWidget * active_menuitem;

   /* Access widget to get state 
       and modifying the prefs struct */

    set_showdate(prefs,gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(radio1)));
    set_showsize(prefs,gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(radio2)));
    set_showlocal(prefs,gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(radio3)));
    set_showtype(prefs,gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(radio4)));
    set_noimg(prefs,gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(radio5)));
    set_extitle(prefs,gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(radio6)));
    
    active_menuitem = gtk_menu_get_active(GTK_MENU(menu));
  
    for (i = 0; i<7; i++)
      if (active_menuitem == menu_tab[i])
	set_sortby(prefs,i);
 
    set_resultdirectory(prefs, gtk_entry_get_text(GTK_ENTRY(entry)));
    set_cachedirectory(prefs, gtk_entry_get_text(GTK_ENTRY(entry2)));
    set_runbrowser(prefs, gtk_entry_get_text(GTK_ENTRY(entry3)));

    /* Write prefs to disk, thus validate modification made */
    amyc_put_prefs (prefs);

    /* close the config window */
    gtk_widget_destroy (fenetre);
}

void
config_cancel (GtkWidget *fenetre, GtkButton * button)
{
    /* Reload prefs from disk, thus canceling any modification made */
    amyc_get_prefs (prefs);
    /* close the config window */
    gtk_widget_destroy (fenetre);
}

void 
config_window(GtkButton *button, gpointer user_data) 
{
    int i;
    GtkWidget *window, *table;

    GtkWidget *label1, *label2, *label3, *label4, *boutton1, *boutton2;
    GtkWidget *sortby_w;

    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title(GTK_WINDOW(window), _("Configuration"));
    /* Not resizeable (+ or -), no maximize gadget */
    gtk_window_set_policy(GTK_WINDOW(window), FALSE, FALSE, FALSE);
    gtk_window_set_modal(GTK_WINDOW(window), TRUE); 
   
    menu = gtk_menu_new();
    sortby_w = gtk_option_menu_new (); 

    menu_tab[SORT_NOSORT] = gtk_menu_item_new_with_label(_("(unsorted)"));
    menu_tab[SORT_BY_FILEDATE] = gtk_menu_item_new_with_label(_("Date"));
    menu_tab[SORT_BY_URL]  = gtk_menu_item_new_with_label(_("Url"));
    menu_tab[SORT_BY_TYPEURL] = gtk_menu_item_new_with_label(_("Type/Url"));
    menu_tab[SORT_BY_TYPEDATE] = gtk_menu_item_new_with_label(_("Type/Date"));
    menu_tab[SORT_BY_TYPESIZE] = gtk_menu_item_new_with_label(_("Type/Size"));
    menu_tab[SORT_BY_SIZEURL] = gtk_menu_item_new_with_label(_("Size/Url"));

    for (i = 0; i<7; i++)
      gtk_menu_append(GTK_MENU(menu),menu_tab[i]);
   
    entry = gtk_entry_new();
    entry2 = gtk_entry_new();
    entry3 = gtk_entry_new();

    label1 = gtk_label_new(_("Result directory"));
    label2 = gtk_label_new(_("Cache directory"));
    label3 = gtk_label_new(_("Run browser"));
    label4 = gtk_label_new(_("Sort by"));

    radio1 = gtk_check_button_new_with_label(_("Show date"));
    radio2 =  gtk_check_button_new_with_label(_("Show size"));
    radio3 =  gtk_check_button_new_with_label(_("Show local name"));
    radio4 =  gtk_check_button_new_with_label(_("Show type"));
    radio5 =  gtk_check_button_new_with_label(_("No images"));
    radio6 =  gtk_check_button_new_with_label(_("Extract title"));

    /* Positioning check box according to the prefs file */
    if (amyc_showdate (prefs))
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON((radio1)), TRUE);
    if (amyc_showsize (prefs))
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON((radio2)), TRUE);
    if (amyc_showlocal (prefs))
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio3), TRUE);
    if (amyc_showtype (prefs))
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio4), TRUE);
    if (amyc_noimg (prefs))
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio5), TRUE);
    if (amyc_extitle (prefs))
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(radio6), TRUE);

    if (amyc_sortby (prefs))
	gtk_menu_set_active(GTK_MENU(menu), amyc_sortby (prefs));
    gtk_option_menu_set_menu(GTK_OPTION_MENU(sortby_w),menu);
  
    gtk_entry_set_text((GtkEntry *) entry,amyc_resultdirectory(prefs));
    gtk_entry_set_text((GtkEntry *) entry2,amyc_cachedirectory(prefs));
    gtk_entry_set_text((GtkEntry *) entry3,amyc_getrunbrowser(prefs));

    boutton1 = gtk_button_new_with_label (_(" OK "));
    boutton2 = gtk_button_new_with_label (_(" Cancel "));

    gtk_signal_connect_object (GTK_OBJECT(boutton1), "clicked", 
			       GTK_SIGNAL_FUNC (config_ok), GTK_OBJECT(window) );
    gtk_signal_connect_object (GTK_OBJECT(boutton2), "clicked", 
			       GTK_SIGNAL_FUNC (config_cancel), GTK_OBJECT(window));

    gtk_widget_set_uposition(sortby_w,80,25);  
   
    gtk_widget_set_uposition(radio1,220,5);  
    gtk_widget_set_uposition(radio2,220,24);  
    gtk_widget_set_uposition(radio3,220,43);  
    gtk_widget_set_uposition(radio4,350,5);  
    gtk_widget_set_uposition(radio5,350,24);  
    gtk_widget_set_uposition(radio6,350,43);  

    gtk_widget_set_uposition(entry,120,70);  
    gtk_widget_set_uposition(entry2,120,100);  
    gtk_widget_set_uposition(entry3,120,130);
 
    gtk_widget_set_uposition(label1,20,70);
    gtk_widget_set_uposition(label2,20,100);
    gtk_widget_set_uposition(label3,20,130);
    gtk_widget_set_uposition(label4,20,30);
 
    gtk_widget_set_uposition(boutton1,150,170);
    gtk_widget_set_uposition(boutton2,220,170);
    
    gtk_widget_set_usize(sortby_w,110,25);
   
    gtk_widget_set_usize(entry,300,20);
    gtk_widget_set_usize(entry2,300,20);
    gtk_widget_set_usize(entry3,300,20);

    gtk_widget_set_usize(window,460,210);

    table = gtk_table_new(2,3, FALSE);
    gtk_container_add(GTK_CONTAINER(window), table);

    /* Pack them into a box, then show all the widgets */
    gtk_table_attach(GTK_TABLE(table), sortby_w, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), radio1, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), radio2, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), radio3, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), radio4, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), radio5, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), radio6, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), entry, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), entry2, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), entry3, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), label1, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), label2, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), label3, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), label4, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), boutton1, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), boutton2, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    
    gtk_container_add(GTK_CONTAINER(window), table);
    gtk_widget_show_all (window);
    return;
 }

void
remove_cancel (GtkWidget *fenetre, GtkButton * button)
{
    gtk_widget_destroy(fenetre);  /* close the "reomve url" window */
}

void
remove_ok (GtkWidget *fenetre, GtkButton * button)
{
  /* Insert here code to read the text entry and call remove url in amyc_ns */
    /*  g_print( gtk_entry_get_text(GTK_ENTRY(entry_removeurl))); */

  /* Return value is ignored for now */
  remove_url (prefs, gtk_entry_get_text(GTK_ENTRY(entry_removeurl)));

    gtk_widget_destroy(fenetre);  /* close the config window */

}

void 
removeurl_window ( GtkButton * button, gpointer user_data ) 
{

    GtkWidget *window, *table, * label, *boutton_ok, *boutton_cancel;

    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title(GTK_WINDOW(window), _("Remove URL"));
    /* Not resizeable (+ or -), no maximize gadget */
    gtk_window_set_policy(GTK_WINDOW(window), FALSE, FALSE, FALSE);
    gtk_window_set_modal(GTK_WINDOW(window), TRUE);
 
    label = gtk_label_new("Remove URL :");
    entry_removeurl = gtk_entry_new();

    boutton_ok = gtk_button_new_with_label (_(" OK "));
    boutton_cancel = gtk_button_new_with_label (_(" Cancel "));

    gtk_signal_connect_object (GTK_OBJECT(boutton_ok), "clicked", 
	 GTK_SIGNAL_FUNC (remove_ok), GTK_OBJECT(window) ); 
    gtk_signal_connect_object (GTK_OBJECT(boutton_cancel), "clicked", 
	 GTK_SIGNAL_FUNC (remove_cancel), GTK_OBJECT(window) ); 
 
    gtk_widget_set_uposition(label,70,30);
    gtk_widget_set_uposition(entry_removeurl,70,50);
    gtk_widget_set_uposition(boutton_ok,150,107);
    gtk_widget_set_uposition(boutton_cancel,190,107);
    gtk_widget_set_usize (window, 277, 137);

    table = gtk_table_new(2,3, FALSE);
    gtk_container_add(GTK_CONTAINER(window), table);

    /* Pack them into a box, then show all the widgets */
    gtk_table_attach(GTK_TABLE(table), label, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), boutton_ok, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), boutton_cancel, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), entry_removeurl, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    
    gtk_container_add(GTK_CONTAINER(window), table);
    gtk_widget_show_all (window);
    return;
}

void
about_ok (GtkWidget *fenetre, GtkButton * button)
{
    gtk_widget_destroy(fenetre);  /* close the "about" window */
}

void 
about_window ( GtkButton * button, gpointer user_data ) 
{

    GtkWidget *window, *table, * label1, *label2, *label3, *bouton1;

    window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title(GTK_WINDOW(window), _("About..."));
    /* Not resizeable (+ or -), no maximize gadget */
    gtk_window_set_policy(GTK_WINDOW(window), FALSE, FALSE, FALSE);
    gtk_window_set_modal(GTK_WINDOW(window), TRUE);
 
    label1 = gtk_label_new(AMYC_NAME " " VERSION);
    label2 = gtk_label_new("Francois Crevola");
    label3 = gtk_label_new("francois@crevola.com");
    
    bouton1 = gtk_button_new_with_label (_(" OK "));
 
    gtk_signal_connect_object (GTK_OBJECT(bouton1), "clicked", 
	 GTK_SIGNAL_FUNC (about_ok), GTK_OBJECT(window) ); 
 
    gtk_widget_set_uposition(label1,70,30);
    gtk_widget_set_uposition(label2,70,45);
    gtk_widget_set_uposition(label3,70,75);
 
    gtk_widget_set_uposition(bouton1,130,107);
    gtk_widget_set_usize (window, 277, 137);

    table = gtk_table_new(2,3, FALSE);
    gtk_container_add(GTK_CONTAINER(window), table);

    /* Pack them into a box, then show all the widgets */
    gtk_table_attach(GTK_TABLE(table), label1, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), label2, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), label3, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    gtk_table_attach(GTK_TABLE(table), bouton1, 0,2, 2,3, GTK_EXPAND, GTK_EXPAND,0,0);
    
    gtk_container_add(GTK_CONTAINER(window), table);
    gtk_widget_show_all (window);
    return;
}

int 
main (int argc,
      char *argv[])
{
    /* GtkWidget is the storage type for widgets */

    GtkWidget *window, *table;
    GtkWidget *boutton1, *boutton2, *boutton3, *boutton4, *boutton5, *boutton6,
     *boutton7;

    GtkWidget *pixmapwid;
    GdkPixmap *pixmap;
    GdkBitmap *mask;
    GtkStyle *style;

#if ENABLE_NLS
    setlocale (LC_MESSAGES, "");
    bindtextdomain (PACKAGE, LOCALEDIR);
    textdomain (PACKAGE);
#endif

    prefs = amyc_new(); /* Init */
    amyc_get_prefs (prefs); 

    gtk_init (&argc, &argv);

    /* create a new window */
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title (GTK_WINDOW (window), AMYC_NAME);
    /* Not resizeable (+ or -), no maximize gadget */
    gtk_window_set_policy (GTK_WINDOW (window), FALSE, FALSE, FALSE);

    gtk_signal_connect (GTK_OBJECT (window), "delete_event",
			GTK_SIGNAL_FUNC (delete_event), NULL);

    gtk_signal_connect (GTK_OBJECT (window), "destroy",
			GTK_SIGNAL_FUNC (destroy), NULL);

    /* Sets the border width of the window. */
    gtk_container_set_border_width (GTK_CONTAINER (window), 10);
    /* added to avoid a gtk warning */
    gtk_widget_show (window);

/* now for the pixmap from gdk */
    style = gtk_widget_get_style (window);
    pixmap = gdk_pixmap_create_from_xpm_d (window->window, &mask,
					   &style->bg[GTK_STATE_NORMAL],
					   (gchar **) amyc_logo);

    /* a pixmap widget to contain the pixmap */
    pixmapwid = gtk_pixmap_new (pixmap, mask);

    table = gtk_table_new (3, 2, FALSE);
    gtk_container_add (GTK_CONTAINER (window), table);

    boutton1 = gtk_button_new_with_label (_("Start analysis"));
    boutton2 = gtk_button_new_with_label (_("Run browser"));
    boutton3 = gtk_button_new_with_label (_("Configuration"));
    boutton4 = gtk_button_new_with_label (_("Remove URL"));
    boutton5 = gtk_button_new_with_label (_("Help"));
    boutton6 = gtk_button_new_with_label (_("Quit"));
    boutton7 = gtk_button_new_with_label (_("About..."));

    gtk_signal_connect (GTK_OBJECT(boutton1), "clicked", 
		      GTK_SIGNAL_FUNC (startanalysis), NULL);
    gtk_signal_connect (GTK_OBJECT(boutton2), "clicked", 
		      GTK_SIGNAL_FUNC (runbrowser), NULL);
    gtk_signal_connect (GTK_OBJECT(boutton3), "clicked", 
		      GTK_SIGNAL_FUNC (config_window), NULL);
    gtk_signal_connect (GTK_OBJECT(boutton4), "clicked", 
		      GTK_SIGNAL_FUNC (removeurl_window), NULL);
    gtk_signal_connect (GTK_OBJECT(boutton7), "clicked", 
		      GTK_SIGNAL_FUNC (about_window), NULL);

    gtk_table_attach (GTK_TABLE (table), boutton1, 0, 2, 2, 3, GTK_EXPAND, GTK_EXPAND, 0, 0);
    gtk_table_attach (GTK_TABLE (table), boutton2, 1, 2, 1, 2, GTK_EXPAND, GTK_EXPAND, 0, 0);
    gtk_table_attach (GTK_TABLE (table), boutton3, 1, 2, 1, 2, GTK_EXPAND, GTK_EXPAND, 0, 0);
    gtk_table_attach (GTK_TABLE (table), boutton4, 1, 2, 1, 2, GTK_EXPAND, GTK_EXPAND, 0, 0);
    gtk_table_attach (GTK_TABLE (table), boutton5, 1, 2, 1, 2, GTK_EXPAND, GTK_EXPAND, 0, 0);
    gtk_table_attach (GTK_TABLE (table), boutton6, 1, 2, 1, 2, GTK_EXPAND, GTK_EXPAND, 0, 0);
    gtk_table_attach (GTK_TABLE (table), boutton7, 1, 2, 1, 2, GTK_EXPAND, GTK_EXPAND, 0, 0);

    gtk_table_attach (GTK_TABLE (table), pixmapwid, 1, 2, 1, 2, GTK_EXPAND, GTK_EXPAND, 0, 0);
    gtk_widget_set_uposition (pixmapwid, 2, 32);
    gtk_widget_show (pixmapwid);

    gtk_widget_set_uposition (boutton1, 42, 11);
    gtk_widget_set_uposition (boutton2, 162, 11);
    gtk_widget_set_uposition (boutton3, 42, 51);
    gtk_widget_set_uposition (boutton4, 162, 51);

    gtk_widget_set_uposition (boutton5, 7, 101);
    gtk_widget_set_uposition (boutton6, 98, 101);
    gtk_widget_set_uposition (boutton7, 190, 101);

    gtk_widget_set_usize (boutton1, 108, 28);
    gtk_widget_set_usize (boutton2, 108, 28);
    gtk_widget_set_usize (boutton3, 108, 28);
    gtk_widget_set_usize (boutton4, 108, 28);

    gtk_widget_set_usize (boutton5, 80, 28);
    gtk_widget_set_usize (boutton6, 80, 28);
    gtk_widget_set_usize (boutton7, 80, 28);

    gtk_widget_set_usize (window, 277, 137);

    gtk_signal_connect_object (GTK_OBJECT (boutton6), "clicked",
			       GTK_SIGNAL_FUNC (gtk_widget_destroy),
			       GTK_OBJECT (window));

    gtk_widget_show_all (window);
    gtk_main ();
    return (EXIT_SUCCESS);
}
