/* About My Cache (for Unix)
   by Francois Crevola 
 */

#include <config.h>

#if ENABLE_NLS
#include <libintl.h>
#  define _(String) gettext (String)
#else
#  define _(String) (String)
#endif /* ENABLE_NLS */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "amyc_prefs.h"

int 
main (int argc, char *argv[])
{
    int use_stdout = 0;
    amyc_prefs amyc;

#if ENABLE_NLS
    setlocale (LC_MESSAGES, "");
    bindtextdomain (PACKAGE, LOCALEDIR);
    textdomain (PACKAGE);
#endif
    
    if (argc > 2) {
	fprintf (stderr, "Syntax : %s [--stdout]\n", argv[0] );
	return (EXIT_FAILURE);
    }

    if ((argc == 2) && (!strcmp (argv[1], "--stdout"))) 
	use_stdout = 1;

    amyc = amyc_new ();
    amyc_seq (amyc, use_stdout);

    return (EXIT_SUCCESS);
}
