#ifndef _AMYC_NS_H
#define _AMYC_NS_H

#include <config.h>

/* include for db1 */
#ifdef HAVE_DB1_DB_H
#  include <db1/db.h>
#else
#  ifdef HAVE_DB_185_H
#    include <db_185.h>
#  else
#    include <db.h>
#  endif /* HAVE_DB_185_H */
#endif /* HAVE_DB1_DB_H */

#include <stdio.h>
#include <sys/types.h>
#include "amyc_prefs.h"

#define FILE_NOT_FOUND -2
#define LINE_LEN 256

/* Constant for sort criteria */
/* should name be changed to reflect name in the cache_entry struct ? */

#define SORT_NOSORT      0
#define SORT_BY_FILEDATE 1
#define SORT_BY_URL      2
#define SORT_BY_TYPEURL  3
#define SORT_BY_TYPEDATE 4
#define SORT_BY_TYPESIZE 5
#define SORT_BY_SIZEURL  6

/* Url per page */

#define URL_ALL 0
#define URL_100 1
#define URL_250 2
#define URL_500 3

extern void amyc_ns_seq (amyc_prefs prefs, FILE *output);
extern int remove_url (amyc_prefs prefs, char * URL);

#endif
